/* check whether find and find_next returns the right element, with
   and without context */
#include "common_gadl.h"

static int cmp(void *i_, void *str_)
{
	item_t *i = i_;
	char *str = str_;

	if (i == NULL)
		return !(str == NULL);
	return !strstr(i->payload, str);
}

static int dummy_ctx;
static int ctxcmp(void *ctx, void *i_, void *str_)
{
	item_t *i = i_;
	char *str = str_;

	assert(ctx == &dummy_ctx);
	return cmp(i, str);
}

int main()
{
	item_t *a, *b;

	list1 = gadl_list_init(NULL, sizeof(item_t), NULL, NULL);
	init_fill(list1, 5);
	dump_list(list1, "INIT");

	a = gadl_find(list1, "2", cmp);
	printf("First:  %s\n", elem2str(a));

	b = gadl_find_next(a, "fill", cmp);
	printf("Next:   %s\n", elem2str(b));

	a = gadl_ctxfind(list1, "2", ctxcmp, &dummy_ctx);
	printf("CFirst: %s\n", elem2str(a));

	b = gadl_ctxfind_next(a, "fill", ctxcmp, &dummy_ctx);
	printf("CNext:  %s\n", elem2str(b));

	return 0;
}
