/* check whether find and find_next returns the right element, with
   and without context */
#include "common_gdl.h"

static int cmp(item_t *i, char *str)
{
	if (i == NULL)
		return !(str == NULL);
	return !strstr(i->payload, str);
}

static int ctxcmp(int ctx, item_t *i, char *str)
{
	assert(ctx == 42);
	return cmp(i, str);
}

int main()
{
	item_t *a, *b;

	init_fill(&list1, 5);
	dump_list1("INIT");

	gdl_find(&list1, "2", cmp, &a);
	printf("First:  %s\n", elem2str(a));

	gdl_find_next(&list1, a, "fill", cmp, &b);
	printf("Next:   %s\n", elem2str(b));

	gdl_ctxfind(&list1, "2", ctxcmp, 42, &a);
	printf("CFirst: %s\n", elem2str(a));

	gdl_ctxfind_next(&list1, a, "fill", ctxcmp, 42, &b);
	printf("CNext:  %s\n", elem2str(b));

	return 0;
}
